//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private DeltaSurge[] cacheDeltaSurge = null;

        private static DeltaSurge checkDeltaSurge = new DeltaSurge();

        /// <summary>
        /// Order Flows Delta Surge
        /// </summary>
        /// <returns></returns>
        public DeltaSurge DeltaSurge(long barAMinimumVolume, long barBMinimumVolume, long barCMinimumDeltaDifference, long barCMinimumVolume, long barDMinimumDeltaDifference, long barDMinimumVolume, int signalBoxHeight, int signalBoxOpacity, int signalBoxWidth, int signalDisplacement)
        {
            return DeltaSurge(Input, barAMinimumVolume, barBMinimumVolume, barCMinimumDeltaDifference, barCMinimumVolume, barDMinimumDeltaDifference, barDMinimumVolume, signalBoxHeight, signalBoxOpacity, signalBoxWidth, signalDisplacement);
        }

        /// <summary>
        /// Order Flows Delta Surge
        /// </summary>
        /// <returns></returns>
        public DeltaSurge DeltaSurge(Data.IDataSeries input, long barAMinimumVolume, long barBMinimumVolume, long barCMinimumDeltaDifference, long barCMinimumVolume, long barDMinimumDeltaDifference, long barDMinimumVolume, int signalBoxHeight, int signalBoxOpacity, int signalBoxWidth, int signalDisplacement)
        {
            if (cacheDeltaSurge != null)
                for (int idx = 0; idx < cacheDeltaSurge.Length; idx++)
                    if (cacheDeltaSurge[idx].BarAMinimumVolume == barAMinimumVolume && cacheDeltaSurge[idx].BarBMinimumVolume == barBMinimumVolume && cacheDeltaSurge[idx].BarCMinimumDeltaDifference == barCMinimumDeltaDifference && cacheDeltaSurge[idx].BarCMinimumVolume == barCMinimumVolume && cacheDeltaSurge[idx].BarDMinimumDeltaDifference == barDMinimumDeltaDifference && cacheDeltaSurge[idx].BarDMinimumVolume == barDMinimumVolume && cacheDeltaSurge[idx].SignalBoxHeight == signalBoxHeight && cacheDeltaSurge[idx].SignalBoxOpacity == signalBoxOpacity && cacheDeltaSurge[idx].SignalBoxWidth == signalBoxWidth && cacheDeltaSurge[idx].SignalDisplacement == signalDisplacement && cacheDeltaSurge[idx].EqualsInput(input))
                        return cacheDeltaSurge[idx];

            lock (checkDeltaSurge)
            {
                checkDeltaSurge.BarAMinimumVolume = barAMinimumVolume;
                barAMinimumVolume = checkDeltaSurge.BarAMinimumVolume;
                checkDeltaSurge.BarBMinimumVolume = barBMinimumVolume;
                barBMinimumVolume = checkDeltaSurge.BarBMinimumVolume;
                checkDeltaSurge.BarCMinimumDeltaDifference = barCMinimumDeltaDifference;
                barCMinimumDeltaDifference = checkDeltaSurge.BarCMinimumDeltaDifference;
                checkDeltaSurge.BarCMinimumVolume = barCMinimumVolume;
                barCMinimumVolume = checkDeltaSurge.BarCMinimumVolume;
                checkDeltaSurge.BarDMinimumDeltaDifference = barDMinimumDeltaDifference;
                barDMinimumDeltaDifference = checkDeltaSurge.BarDMinimumDeltaDifference;
                checkDeltaSurge.BarDMinimumVolume = barDMinimumVolume;
                barDMinimumVolume = checkDeltaSurge.BarDMinimumVolume;
                checkDeltaSurge.SignalBoxHeight = signalBoxHeight;
                signalBoxHeight = checkDeltaSurge.SignalBoxHeight;
                checkDeltaSurge.SignalBoxOpacity = signalBoxOpacity;
                signalBoxOpacity = checkDeltaSurge.SignalBoxOpacity;
                checkDeltaSurge.SignalBoxWidth = signalBoxWidth;
                signalBoxWidth = checkDeltaSurge.SignalBoxWidth;
                checkDeltaSurge.SignalDisplacement = signalDisplacement;
                signalDisplacement = checkDeltaSurge.SignalDisplacement;

                if (cacheDeltaSurge != null)
                    for (int idx = 0; idx < cacheDeltaSurge.Length; idx++)
                        if (cacheDeltaSurge[idx].BarAMinimumVolume == barAMinimumVolume && cacheDeltaSurge[idx].BarBMinimumVolume == barBMinimumVolume && cacheDeltaSurge[idx].BarCMinimumDeltaDifference == barCMinimumDeltaDifference && cacheDeltaSurge[idx].BarCMinimumVolume == barCMinimumVolume && cacheDeltaSurge[idx].BarDMinimumDeltaDifference == barDMinimumDeltaDifference && cacheDeltaSurge[idx].BarDMinimumVolume == barDMinimumVolume && cacheDeltaSurge[idx].SignalBoxHeight == signalBoxHeight && cacheDeltaSurge[idx].SignalBoxOpacity == signalBoxOpacity && cacheDeltaSurge[idx].SignalBoxWidth == signalBoxWidth && cacheDeltaSurge[idx].SignalDisplacement == signalDisplacement && cacheDeltaSurge[idx].EqualsInput(input))
                            return cacheDeltaSurge[idx];

                DeltaSurge indicator = new DeltaSurge();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.BarAMinimumVolume = barAMinimumVolume;
                indicator.BarBMinimumVolume = barBMinimumVolume;
                indicator.BarCMinimumDeltaDifference = barCMinimumDeltaDifference;
                indicator.BarCMinimumVolume = barCMinimumVolume;
                indicator.BarDMinimumDeltaDifference = barDMinimumDeltaDifference;
                indicator.BarDMinimumVolume = barDMinimumVolume;
                indicator.SignalBoxHeight = signalBoxHeight;
                indicator.SignalBoxOpacity = signalBoxOpacity;
                indicator.SignalBoxWidth = signalBoxWidth;
                indicator.SignalDisplacement = signalDisplacement;
                Indicators.Add(indicator);
                indicator.SetUp();

                DeltaSurge[] tmp = new DeltaSurge[cacheDeltaSurge == null ? 1 : cacheDeltaSurge.Length + 1];
                if (cacheDeltaSurge != null)
                    cacheDeltaSurge.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cacheDeltaSurge = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Order Flows Delta Surge
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.DeltaSurge DeltaSurge(long barAMinimumVolume, long barBMinimumVolume, long barCMinimumDeltaDifference, long barCMinimumVolume, long barDMinimumDeltaDifference, long barDMinimumVolume, int signalBoxHeight, int signalBoxOpacity, int signalBoxWidth, int signalDisplacement)
        {
            return _indicator.DeltaSurge(Input, barAMinimumVolume, barBMinimumVolume, barCMinimumDeltaDifference, barCMinimumVolume, barDMinimumDeltaDifference, barDMinimumVolume, signalBoxHeight, signalBoxOpacity, signalBoxWidth, signalDisplacement);
        }

        /// <summary>
        /// Order Flows Delta Surge
        /// </summary>
        /// <returns></returns>
        public Indicator.DeltaSurge DeltaSurge(Data.IDataSeries input, long barAMinimumVolume, long barBMinimumVolume, long barCMinimumDeltaDifference, long barCMinimumVolume, long barDMinimumDeltaDifference, long barDMinimumVolume, int signalBoxHeight, int signalBoxOpacity, int signalBoxWidth, int signalDisplacement)
        {
            return _indicator.DeltaSurge(input, barAMinimumVolume, barBMinimumVolume, barCMinimumDeltaDifference, barCMinimumVolume, barDMinimumDeltaDifference, barDMinimumVolume, signalBoxHeight, signalBoxOpacity, signalBoxWidth, signalDisplacement);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Order Flows Delta Surge
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.DeltaSurge DeltaSurge(long barAMinimumVolume, long barBMinimumVolume, long barCMinimumDeltaDifference, long barCMinimumVolume, long barDMinimumDeltaDifference, long barDMinimumVolume, int signalBoxHeight, int signalBoxOpacity, int signalBoxWidth, int signalDisplacement)
        {
            return _indicator.DeltaSurge(Input, barAMinimumVolume, barBMinimumVolume, barCMinimumDeltaDifference, barCMinimumVolume, barDMinimumDeltaDifference, barDMinimumVolume, signalBoxHeight, signalBoxOpacity, signalBoxWidth, signalDisplacement);
        }

        /// <summary>
        /// Order Flows Delta Surge
        /// </summary>
        /// <returns></returns>
        public Indicator.DeltaSurge DeltaSurge(Data.IDataSeries input, long barAMinimumVolume, long barBMinimumVolume, long barCMinimumDeltaDifference, long barCMinimumVolume, long barDMinimumDeltaDifference, long barDMinimumVolume, int signalBoxHeight, int signalBoxOpacity, int signalBoxWidth, int signalDisplacement)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.DeltaSurge(input, barAMinimumVolume, barBMinimumVolume, barCMinimumDeltaDifference, barCMinimumVolume, barDMinimumDeltaDifference, barDMinimumVolume, signalBoxHeight, signalBoxOpacity, signalBoxWidth, signalDisplacement);
        }
    }
}
#endregion
